main () {

  setUpFx();

}

setUpFx() {

  if (getcvar("g_gametype") == "cnq" ) {
    //conquest specific code
  	cacheFx();
  	cacheModels();
  	startSmoke();  
  	startSounds();
  	startFlashes();
  	startMortars();
    setupCallbacks();
    startFlak();
  }
}

setupCallbacks() {
  level.cnqCallbackSpawnObjectiveComplete = ::Callback_SpawnObjectiveComplete;
  level.cnqCallbackBonusObjectiveComplete = ::Callback_BonusObjectiveComplete;
  level.cnqCallbackBonusObjectiveRegen =  ::Callback_BonusRegen;  
}

Callback_SpawnObjectiveComplete(objective, player) {

  objective playsound ("ts");

  if ((level._flakalive == 1) && (objective.script_idnumber == 3) && (player.pers["team"] == game["attackers"])) {
    level._flakalive = 0;
    wait 10;
	  flak1 = getent ("flak", "targetname");
    if (isdefined(flak1))
      flak1 thread attack();
  }
}

Callback_BonusObjectiveComplete(objective, player) {
  objective playsound ("ts");
  maps\mp\_fx::loopfx("spk", objective.origin, 3.0, undefined, "spk", "spk");
  wait 0.5;
  level notify("start fxspk");
}

Callback_BonusRegen(objective) {
  wait 0.5;	
  level notify("stop fxspk");
}
cacheModels() {
  precachemodel("xmodel/turret_flak88_static_antiairlow");
  precachemodel("xmodel/turret_flak88_static_antiairlow_d");
  precachemodel("xmodel/artillery_german_granatwerfer");
}

cacheFx() {
 	level._effect["smk"]   = loadfx ("fx/smoke/slow_steam.efx");
	level._effect["smk2"]   = loadfx ("fx/smoke/linger_smoke.efx");
//	level._effect["smoke3"]   = loadfx ("fx/smoke/linger_smoke.efx");
//	level._effect["smoke4"]   = loadfx ("fx/smoke/blacksmokelinger.efx");
//	level._effect["smoke5"]   = loadfx ("fx/fire/distantfire.efx");
//	level._effect["smoke6"]   = loadfx ("fx/smoke/linger_smoke.efx");
//	level._effect["smoke7"]   = loadfx ("fx/smoke/firesmoke_l.efx");
//	level._effect["smoke8"]   = loadfx ("fx/fire/distantfire.efx");
  level._effect["smk9"] = loadfx ("fx/smoke/dawnville_smoke.efx");
  level._effect["smk3"] = loadfx ("fx/smoke/dawnville_smoke3.efx");
	level._effect["flkb"] = loadfx ("fx/muzzleflashes/flakkflash.efx");
  level._effect["flkbl"] = loadfx ("fx/muzzleflashes/flaktemp_nolight.efx");
//  level._effect["aftereffec1"] = loadfx ("fx/surfacehits/aftereffec1.efx");
	level._effect["bu"]= loadfx("fx/explosions/explosion1.efx");
  level._effect["hit1"] = loadfx ("fx/impacts/largemortar_dirt.efx");
//  level._effect["mortar1"] = loadfx ("fx/impacts/mortar1.efx");
//  level._effect["mortar1nolight"] = loadfx ("fx/impacts/mortar1nolight.efx");
  level._effect["hit2"] = loadfx ("fx/impacts/dirthit_mortar.efx");
  level._effect["mhit"] = loadfx ("fx/surfacehits/dawnville_mortar.efx");
	level._effect["mflsh"]= loadfx("fx/muzzleflashes/mortarflash.efx");
//	level._effect["motarsmoke_em"] = loadfx ("fx/muzzleflashes/motarsmoke_em.efx");
  level._effect["fl"] = loadfx ("fx/atmosphere/longrangeflash_altocloud.efx");
  level._effect["spk"] = loadfx ("fx/misc/sparker.efx");

}

startSmoke() {
	maps\mp\_fx::loopfx("smk", (1120, 4045, 10), 0.1);
	maps\mp\_fx::loopfx("smk2", (-5120, -2404, 100), 0.3);
	maps\mp\_fx::loopfx("smk2", (-5400, -2980, 100), 0.3);
	maps\mp\_fx::loopfx("smk2", (-5376, -1952, 128), 0.3);
	maps\mp\_fx::loopfx("smk2", (-5600, -1760, 100), 0.3);
	maps\mp\_fx::loopfx("smk2", (-6200, 3600, 500), 0.3);

}


startFlashes() {
  flashes = getentarray("flash", "targetname");
  if (isdefined(flashes)) {
    for (i = 0; i < flashes.size; i++ ) {
      flashes[i] thread flash_think();
    }
  }
}

flash_think() {
 
  while (1) {
    self playFlash();
    wait (randomint(2)*1);
  }
  
}

playFlash () {
  playfx (level._effect["fl"], self.origin );
  wait 5;
  self playsound ("al"); //distant arty fires a shot  
}


startSounds() {
  
  radios = getentarray("radio", "targetname");
  if (isdefined(radios)) {
    for (i = 0; i < radios.size; i++ ) {
      radios[i] playloopsound ("radio");
    }
  } 
  
  campfire = getent("camp", "targetname");
  if (isdefined(campfire)) {
    campfire playloopsound ("cf");
  } 
  
  
}

startFlak() {
	flak1 = getent ("flak", "targetname");
  level._flakalive = 1;
  if (isdefined(flak1))
    flak1 thread shootFlak();
}

startMortars() {

  mortars = getentarray ("mort", "targetname");
  for (m = 0; m < mortars.size; m++) 
    mortars[m] thread mortar_think();
}

mortar_think() {
 
  self.mortar = getent(self.target, "targetname");
  if (!isdefined(self.mortar)) return;
  
  self.targets = getentarray(self.mortar.target, "targetname");
  if (!isdefined(self.targets)) return;
    
  if (self.targets.size < 1)
    return;

  self.mortar setmodel ("xmodel/artillery_german_granatwerfer");

  for (;;) {
            
    self waittill("trigger", other);
    self thread shoot_mortar();
    
    wait 3;
    
  }
  
}

shoot_mortar() {
    self.mortar playsound ("gaml"); 
    wait 0.5;
    maps\mp\_fx::OneShotfx("mflsh", (-4031.3, 3182.3, 12.3), 0, (-3993.5,3182.8,69.4));
    self.mortar playsound ("gamh"); 
    impact = self.targets[randomint(self.targets.size-1)]; 
    wait 1;
		impact playsound ("gami");
    wait 3;
    maps\mp\_fx::OneShotfx("mhit", (impact.origin), 0);
    impact playsound ("grenade_explode_default");
    range = 420;  //mortars get 20% increase in range and power over nades
		maxdamage = 145; //20% more than nades
		mindamage = 5; //same min as nades
  	radiusDamage (impact.origin + (0,0,12), range, maxdamage, mindamage);
  	earthquake(0.3, 1, impact.origin, 850); // scale duration source radius
}


shootFlak() {
  self setmodel ("xmodel/turret_flak88_static_antiairlow");
  self endon ("flakdead");
  for (;;) {
    if (randomint(4) < 2) //25% chance of seeing round tracer
      maps\mp\_fx::OneShotfx("flkbl", (1940, 6408, 490),0, (1850, 6260, 534)); 
    maps\mp\_fx::OneShotfx("flkb", (1940, 6408, 490),0, (1850, 6260, 534));
  	self playsound ("flak88_fire");
    wait (randomint(2)*10);
  }
}

fireShell ( shellhole, fx, incomingSound, blowupsound ) {

  //duration of incoming sounds
//  shellsoundwaits["ai1"] = 1.07;
//  shellsoundwaits["ai2"] = .67;
  shellsoundwaits["ai3"] = 2.22;
  shellsoundwaits["ai4"] = 2.15;
  
  wait (randomint(3) * 3);
  artysource = getent("artsrc", "targetname");
  if (isdefined(artysource)) {
    artysource playsound ("al"); //distant arty fires a shot
  }
  wait 10; //arty travels through air
  shellhole  playsound (incomingSound); //INCOMING!!
  wait shellsoundwaits[incomingSound] - 0.25; //wait for the incoming sound to finish
 	playfx (level._effect[fx], shellhole.origin );  //round lands and explodes
  shellhole playsound (blowupsound); //round go BOOM!
  
}


attack() {

  //set up arty barrage

  //get shell landing positions
  shellholes = getentarray(self.target, "targetname");
  if (!isdefined(shellholes)) {
    return; 
  }
  //round impact fx
  shellfx = [];
  shellfx = maps\MP\_utility::add_to_array(shellfx, "hit2");
//  shellfx = maps\MP\_utility::add_to_array(shellfx, "mortar1");
  shellfx = maps\MP\_utility::add_to_array(shellfx, "hit1");
//  shellfx = maps\MP\_utility::add_to_array(shellfx, "mortar1nolight");
  //incoming sounds
  shellsounds = [];
//  shellsounds = maps\MP\_utility::add_to_array(shellsounds, "ai1");
//  shellsounds = maps\MP\_utility::add_to_array(shellsounds, "ai2");
  shellsounds = maps\MP\_utility::add_to_array(shellsounds, "ai3");
  shellsounds = maps\MP\_utility::add_to_array(shellsounds, "ai4");

  // call in arty barrage
//  maxShells = game["scr_ga_artycount"];
//  if (!isdefined(maxShells))
  maxShells = 10;
  // commence fire
  self.doomed = 0;
  for (i = 0; i < maxShells; i++) {
    thread fireShell (shellholes[randomint(shellholes.size-1)],
                       shellfx[randomint(shellfx.size-1)]  , 
                       shellsounds[randomint(shellsounds.size-1)], 
                       "ae" );

    if ((self.doomed == 0) && (i > (maxShells * .75))) { //late in the barrage, Mr Flak gets the coup de grace
      self.doomed = 1;
      self thread nukeFlak();
    }
      
    wait 2;
  }
  // cease fire, target eliminated! :)
}

nukeFlak() {
  
  wait (( randomint(2)*3));

  artysource = getent("artsrc", "targetname");
  if (isdefined(artysource)) {
    wait 1;
    artysource playsound ("al"); //distant arty fires a shot
  }
  wait 10;
  
  self notify("flakdead");
  
  maps\mp\_fx::loopfx("smk9", self.origin, 0.3, undefined,  "smk9", "smk9");
  maps\mp\_fx::loopfx("smk3", self.origin, 0.3, undefined,  "smk3", "smk3");
 	self playsound ("ai2");
  wait 2.2 - 0.25;
 	playfx (level._effect["bu"], self.origin );
 	self playsound ("explo_metal_rand");
  level notify("start fxsmk9");
  level notify("start fxsmk3");
  self setmodel ("xmodel/turret_flak88_static_antiairlow_d");
//	playfx (level._effect["aftereffec1"], self.origin );

  wait 120; //major smoke dies off after 2 mins
  level notify("stop fxsmk9");
}
